#include "angband.h"
#include "cmd-spell.h"



/*!
* @brief jח̈斂@̊es
* @param spell @ID
* @param mode e (SPELL_NAME / SPELL_DESC / SPELL_INFO / SPELL_CAST)
* @return SPELL_NAME / SPELL_DESC / SPELL_INFO ɂ͕|C^ԂBSPELL_CASTNULLԂB
*/
cptr do_crusade_spell(SPELL_IDX spell, BIT_FLAGS mode)
{
	bool name = (mode == SPELL_NAME) ? TRUE : FALSE;
	bool desc = (mode == SPELL_DESC) ? TRUE : FALSE;
	bool info = (mode == SPELL_INFO) ? TRUE : FALSE;
	bool cast = (mode == SPELL_CAST) ? TRUE : FALSE;

	int dir;
	int plev = p_ptr->lev;

	switch (spell)
	{
	case 0:
		if (name) return _("", "Punishment");
		if (desc) return _("d̃{g̓r[B", "Fires a bolt or beam of lightning.");

		{
			int dice = 3 + (plev - 1) / 5;
			int sides = 4;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_bolt_or_beam(beam_chance() - 10, GF_ELEC, dir, damroll(dice, sides));
			}
		}
		break;

	case 1:
		if (name) return _("׈݊m", "Detect Evil");
		if (desc) return _("߂̎׈ȃX^[mB", "Detects all evil monsters in your vicinity.");

		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_monsters_evil(rad);
			}
		}
		break;

	case 2:
		if (name) return _("|", "Remove Fear");
		if (desc) return _("|菜B", "Removes fear.");

		{
			if (cast)
			{
				set_afraid(0);
			}
		}
		break;

	case 3:
		if (name) return _("Ј", "Scare Monster");
		if (desc) return _("X^[1̂|BRƖB", "Attempts to scare a monster.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fear_monster(dir, power);
			}
		}
		break;

	case 4:
		if (name) return _("", "Sanctuary");
		if (desc) return _("אڂSẴX^[𖰂点BRƖB", "Attempts to sleep monsters in the adjacent squares.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				sleep_monsters_touch();
			}
		}
		break;

	case 5:
		if (name) return _("", "Portal");
		if (desc) return _("̃e|[gB", "Teleport medium distance.");

		{
			POSITION range = 25 + plev / 2;

			if (info) return info_range(range);

			if (cast)
			{
				teleport_player(range, 0L);
			}
		}
		break;

	case 6:
		if (name) return _("X^[_Xg", "Star Dust");
		if (desc) return _("^[Qbgt߂ɑM̃{gA˂B", "Fires many bolts of light near the target.");

		{
			int dice = 3 + (plev - 1) / 9;
			int sides = 2;

			if (info) return info_multi_damage_dice(dice, sides);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;
				fire_blast(GF_LITE, dir, dice, sides, 10, 3);
			}
		}
		break;

	case 7:
		if (name) return _("g̏", "Purify");
		if (desc) return _("AŁANOSB", "Heals all cut, stun and poison status.");

		{
			if (cast)
			{
				set_cut(0);
				set_poisoned(0);
				set_stun(0);
			}
		}
		break;

	case 8:
		if (name) return _("׈΂", "Scatter Evil");
		if (desc) return _("׈ȃX^[1̂e|[gBRƖB", "Attempts to teleport an evil monster away.");

		{
			int power = MAX_SIGHT * 5;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;
				fire_ball(GF_AWAY_EVIL, dir, power, 0);
			}
		}
		break;

	case 9:
		if (name) return _("Ȃ", "Holy Orb");
		if (desc) return _("Ȃ͂B׈ȃX^[ɑ΂đ傫ȃ_[W^邪APǂȃX^[ɂ͌ʂȂB",
			"Fires a ball with holy power. Hurts evil monsters greatly, but don't effect good monsters.");

		{
			int dice = 3;
			int sides = 6;
			int rad = (plev < 30) ? 2 : 3;
			int base;

			if (p_ptr->pclass == CLASS_PRIEST ||
				p_ptr->pclass == CLASS_HIGH_MAGE ||
				p_ptr->pclass == CLASS_SORCERER)
				base = plev + plev / 2;
			else
				base = plev + plev / 4;


			if (info) return info_damage(dice, sides, base);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_HOLY_FIRE, dir, damroll(dice, sides) + base, rad);
			}
		}
		break;

	case 10:
		if (name) return _("", "Exorcism");
		if (desc) return _("ȆSẴAfbhyшɃ_[W^A׈ȃX^[|B",
			"Damages all undead and demons in sight, and scares all evil monsters in sight.");

		{
			int sides = plev;
			int power = plev;

			if (info) return info_damage(1, sides, 0);

			if (cast)
			{
				dispel_undead(randint1(sides));
				dispel_demons(randint1(sides));
				turn_evil(power);
			}
		}
		break;

	case 11:
		if (name) return _("", "Remove Curse");
		if (desc) return _("ACeɂア􂢂B", "Removes normal curses from equipped items.");

		{
			if (cast)
			{
				if (remove_curse())
				{
					msg_print(_("NɌĂ悤ȋCB", "You feel as if someone is watching over you."));
				}
			}
		}
		break;

	case 12:
		if (name) return _("F", "Sense Unseen");
		if (desc) return _("莞ԁAȂ̂悤ɂȂB", "Gives see invisible for a while.");

		{
			int base = 24;

			if (info) return info_duration(base, base);

			if (cast)
			{
				set_tim_invis(randint1(base) + base, FALSE);
			}
		}
		break;

	case 13:
		if (name) return _("Ύ׈E", "Protection from Evil");
		if (desc) return _("׈ȃX^[̍UhoA𒣂B", "Gives aura which protect you from evil monster's physical attack.");

		{
			int base = 25;
			int sides = 3 * plev;

			if (info) return info_duration(base, sides);

			if (cast)
			{
				set_protevil(randint1(sides) + base, FALSE);
			}
		}
		break;

	case 14:
		if (name) return _("ق̗", "Judgment Thunder");
		if (desc) return _("͂ȓd̃{gB", "Fires a powerful bolt of lightning.");

		{
			HIT_POINT dam = plev * 5;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;
				fire_bolt(GF_ELEC, dir, dam);
			}
		}
		break;

	case 15:
		if (name) return _("Ȃ䌾t", "Holy Word");
		if (desc) return _("E̎׈ȑ݂ɑ傫ȃ_[W^A̗͂񕜂AŁA|ANOԁASB",
			"Damages all evil monsters in sight, heals HP somewhat, and completely heals poison, fear, stun and cut status.");

		{
			int dam_sides = plev * 6;
			int heal = 100;

			if (info) return format(_(":1d%d/%d", "dam:d%d/h%d"), dam_sides, heal);
			if (cast)
			{
				dispel_evil(randint1(dam_sides));
				hp_player(heal);
				set_afraid(0);
				set_poisoned(0);
				set_stun(0);
				set_cut(0);
			}
		}
		break;

	case 16:
		if (name) return _("Jꂽ", "Unbarring Ways");
		if (desc) return _("꒼̑SĂ㩂Ɣj󂷂B", "Fires a beam which destroy traps and doors.");

		{
			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				destroy_door(dir);
			}
		}
		break;

	case 17:
		if (name) return _("", "Arrest");
		if (desc) return _("׈ȃX^[̓~߂B", "Attempts to paralyze an evil monster.");

		{
			int power = plev * 2;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;
				stasis_evil(dir);
			}
		}
		break;

	case 18:
		if (name) return _("ȂI[", "Holy Aura");
		if (desc) return _("莞ԁA׈ȃX^[鐹ȂI[𓾂B",
			"Gives aura of holy power which injures evil monsters which attacked you for a while.");

		{
			int base = 20;

			if (info) return info_duration(base, base);

			if (cast)
			{
				set_tim_sh_holy(randint1(base) + base, FALSE);
			}
		}
		break;

	case 19:
		if (name) return _("Afbh&ގU", "Dispel Undead & Demons");
		if (desc) return _("ȆSẴAfbhyшɃ_[W^B", "Damages all undead and demons in sight.");

		{
			int sides = plev * 4;

			if (info) return info_damage(1, sides, 0);

			if (cast)
			{
				dispel_undead(randint1(sides));
				dispel_demons(randint1(sides));
			}
		}
		break;

	case 20:
		if (name) return _("׈ގU", "Dispel Evil");
		if (desc) return _("ȆSĂ̎׈ȃX^[Ƀ_[W^B", "Damages all evil monsters in sight.");

		{
			int sides = plev * 4;

			if (info) return info_damage(1, sides, 0);

			if (cast)
			{
				dispel_evil(randint1(sides));
			}
		}
		break;

	case 21:
		if (name) return _("Ȃn", "Holy Blade");
		if (desc) return _("ʏ̕ɖŎׂ̑B", "Makes current weapon especially deadly against evil monsters.");

		{
			if (cast)
			{
				brand_weapon(13);
			}
		}
		break;

	case 22:
		if (name) return _("X^[o[Xg", "Star Burst");
		if (desc) return _("ȑM̋B", "Fires a huge ball of powerful light.");

		{
			HIT_POINT dam = 100 + plev * 2;
			int rad = 4;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_LITE, dir, dam, rad);
			}
		}
		break;

	case 23:
		if (name) return _("Vg", "Summon Angel");
		if (desc) return _("Vg1̏B", "Summons an angel.");

		{
			if (cast)
			{
				bool pet = !one_in_(3);
				u32b flg = 0L;

				if (pet) flg |= PM_FORCE_PET;
				else flg |= PM_NO_PET;
				if (!(pet && (plev < 50))) flg |= PM_ALLOW_GROUP;

				if (summon_specific((pet ? -1 : 0), p_ptr->y, p_ptr->x, (plev * 3) / 2, SUMMON_ANGEL, flg))
				{
					if (pet)
					{
						msg_print(_("upł܂Allv", "'What is thy bidding... Master?'"));
					}
					else
					{
						msg_print(_("ủ͓lɂ炸I s҂A߂Iv", "Mortal! Repent of thy impiousness."));
					}
				}
			}
		}
		break;

	case 24:
		if (name) return _("mCg", "Heroism");
		if (desc) return _("莞ԁAq[[CɂȂB", "Removes fear, and gives bonus to hit and 10 more HP for a while.");

		{
			int base = 25;

			if (info) return info_duration(base, base);

			if (cast)
			{
				(void)heroism(base);
			}
		}
		break;

	case 25:
		if (name) return _("􂢑ގU", "Dispel Curse");
		if (desc) return _("ACeɂ͂Ȏ􂢂B", "Removes normal and heavy curse from equipped items.");

		{
			if (cast)
			{
				if (remove_all_curse())
				{
					msg_print(_("NɌĂ悤ȋCB", "You feel as if someone is watching over you."));
				}
			}
		}
		break;

	case 26:
		if (name) return _("׈Ǖ", "Banish Evil");
		if (desc) return _("ȆSĂ̎׈ȃX^[e|[gBRƖB",
			"Teleports all evil monsters in sight away unless resisted.");

		{
			int power = 100;

			if (info) return info_power(power);

			if (cast)
			{
				if (banish_evil(power))
				{
					msg_print(_("_ȗ͂׈łI", "The holy power banishes evil!"));
				}
			}
		}
		break;

	case 27:
		if (name) return _("n}Qh", "Armageddon");
		if (desc) return _("ӂ̃ACeAX^[An`j󂷂B", "Destroy everything in nearby area.");

		{
			int base = 12;
			int sides = 4;

			if (cast)
			{
				destroy_area(p_ptr->y, p_ptr->x, base + randint1(sides), FALSE);
			}
		}
		break;

	case 28:
		if (name) return _("ڂɂ͖ڂ", "An Eye for an Eye");
		if (desc) return _("莞ԁA_[W󂯂ƂɍUsX^[ɑ΂ē̃_[W^B",
			"Gives special aura for a while. When you are attacked by a monster, the monster are injured with same amount of damage as you take.");

		{
			int base = 10;

			if (info) return info_duration(base, base);

			if (cast)
			{
				set_tim_eyeeye(randint1(base) + base, FALSE);
			}
		}
		break;

	case 29:
		if (name) return _("_̓{", "Wrath of the God");
		if (desc) return _("^[Qbg̎͂ɕ̋𑽐ƂB", "Drops many balls of disintegration near the target.");

		{
			HIT_POINT dam = plev * 3 + 25;
			int rad = 2;

			if (info) return info_multi_damage(dam);

			if (cast)
			{
				if (!cast_wrath_of_the_god(dam, rad)) return NULL;
			}
		}
		break;

	case 30:
		if (name) return _("_", "Divine Intervention");
		if (desc) return _("אڂ郂X^[ɐȂ_[W^AẼX^[Ƀ_[WAANOAA|A^Bɑ̗͂񕜂B",
			"Damages all adjacent monsters with holy power. Damages and attempt to slow, stun, confuse, scare and freeze all monsters in sight. And heals HP.");

		{
			int b_dam = plev * 11;
			int d_dam = plev * 4;
			int heal = 100;
			int power = plev * 4;

			if (info) return format(_("%d/%d+%d", "h%d/dm%d+%d"), heal, d_dam, b_dam / 2);
			if (cast)
			{
				project(0, 1, p_ptr->y, p_ptr->x, b_dam, GF_HOLY_FIRE, PROJECT_KILL, -1);
				dispel_monsters(d_dam);
				slow_monsters(plev);
				stun_monsters(power);
				confuse_monsters(power);
				turn_monsters(power);
				stasis_monsters(power);
				hp_player(heal);
			}
		}
		break;

	case 31:
		if (name) return _("", "Crusade");
		if (desc) return _("ȆPǂȃX^[ybgɂ悤ƂAȂȂꍇyёPǂłȂX^[|Bɑ̉ꂽRmAq[[AjAAΎ׈E𓾂B",
			"Attempts to charm all good monsters in sight, and scare all non-charmed monsters, and summons great number of knights, and gives heroism, bless, speed and protection from evil.");

		{
			if (cast)
			{
				int base = 25;
				int sp_sides = 20 + plev;
				int sp_base = plev;

				int i;
				crusade();
				for (i = 0; i < 12; i++)
				{
					int attempt = 10;
					POSITION my = 0, mx = 0;

					while (attempt--)
					{
						scatter(&my, &mx, p_ptr->y, p_ptr->x, 4, 0);

						/* Require empty grids */
						if (cave_empty_bold2(my, mx)) break;
					}
					if (attempt < 0) continue;
					summon_specific(-1, my, mx, plev, SUMMON_KNIGHTS, (PM_ALLOW_GROUP | PM_FORCE_PET | PM_HASTE));
				}
				set_hero(randint1(base) + base, FALSE);
				set_blessed(randint1(base) + base, FALSE);
				set_fast(randint1(sp_sides) + sp_base, FALSE);
				set_protevil(randint1(base) + base, FALSE);
				set_afraid(0);
			}
		}
		break;
	}

	return "";
}

